import java.awt.*;
import java.util.*;

public class KMP
{
	KMP(){
	}
	
	String text = "";
	String pattern = "";
	public void start(String entry){
		//text = textEntry.getText();
		pattern = entry;
	
		if (pattern.equals("")){
			pattern = set_random(16);
		}
		
		init();
		
	}
	public String set_random(int n){
		String string = "";
		for(int i=0; i<n; i++){
			char c =  (char) ('a' + ((int) 4*Math.random()));
			string += c;
		}
		return string;
	}
	
	
	Font font = new Font("Courier New",  Font.BOLD, 40);
	Font font2 = new Font("Helvetica",  Font.PLAIN, 30);
	int dx = 45;
	public void paint(Graphics g){
		g.setFont(font);
		//drawText(text, g, 10, 60);
		g.drawString("pattern:",10, 60);
		drawText(pattern, g, 250, 60);
		
		
		g.setFont(font2);
		g.drawString("j:",10, 30);
		g.drawString("t:",10, 100);
		g.drawString("next:",10, 140);
		for(int i=0; i<next.length-1; i++){
			g.drawString(""+(i+1),   250+dx*i, 30);	
			g.drawString(""+ts[i+1],   250+dx*i, 100);	
			g.drawString(""+next[i+1], 250+dx*i, 140);	
		}
	}
	public void drawText(String string, Graphics g, int x, int y){
		for(int i=0; i<string.length(); i++){
			g.drawString(""+string.charAt(i), x+dx*i, y);
		}	
	}
	
	
	
	
	
	
	
	// Knuth-Morris-Pratt
	int[] next;
	int[] ts;
	public void init(){
		char[] _pattern = new char[pattern.length()+1];
		for(int i=0; i<pattern.length(); i++)
			_pattern[i+1] = pattern.charAt(i);
		
		next = new int[_pattern.length];
		ts  = new int[_pattern.length];
		int t = 0;
		next[1] = 0;
		for(int j=2; j<_pattern.length; j++){
			while (t > 0 && _pattern[j-1] != _pattern[t])
				t = next[t];
			t++;
			if (_pattern[j] != _pattern[t])
				next[j] = t;
			else
				next[j] = next[t];
			ts[j] = t;
		}
	}
	
}
