import java.awt.event.*;
import java.awt.*;
import java.util.*;


class MainPanel extends Panel implements ButtonsInterface{

	MainPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
	}
	
	
	
	

	//TextField textEntry;
	TextField patternEntry;
	public void initializeButtons(Buttons buttons){
		//textEntry = new TextField(30);
		//buttons.add(textEntry);
		patternEntry = new TextField(30);
		buttons.add(patternEntry);
		buttons.addButton("KMP");
		buttons.addButton("BM");
		buttons.addButton("clear");
		
		algorithm = kmp;
		start();
		
	}
	public void buttonPressed(String label){
		if (label.equals("KMP")){
			algorithm = kmp;
			start();
		}
		else if (label.equals("BM")){
			algorithm = (KMP)bm;
			start();
		}
		else if (label.equals("clear")){
			strokes = new Vector();
			repaint();
		}
	}	
	
	
	
	
	KMP algorithm;
	KMP kmp = new KMP();
	BM bm = new BM();
	public void start(){
		algorithm.start(patternEntry.getText());
		repaint();
	}
	
	
	
	
	
	
	
	
	

	Image buffered_image = null;

	public void update(Graphics g) {
		paint(g);
	}
	BasicStroke basicStroke = new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
	
	public void paint(Graphics g) {

		//double buffering
		if (buffered_image == null)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		bg.clearRect(0,0, getSize().width, getSize().height);

		// paint code!
		Graphics2D g2 = (Graphics2D) bg;
		g2.setStroke(basicStroke);
		bg.setColor(Color.red);
		for(int i=0; i<strokes.size(); i++)
			paint_stroke(bg, (Vector) strokes.elementAt(i));
		bg.setColor(Color.black);
		algorithm.paint(bg);
		
		//double buffering
		bg.dispose();
      
		g.drawImage(buffered_image,0,0,this);

	}

   
   
	
	
	
	public void paint_stroke(Graphics g, Vector stroke){
		for(int i=0; i<stroke.size()-1; i++){
			Point p = (Point) stroke.elementAt(i);
			Point q = (Point) stroke.elementAt(i+1);
			g.drawLine(p.x, p.y, q.x, q.y);
		}
	}
	
	
	
	
	
	
	Vector strokes = new Vector();
	Vector stroke = new Vector();
	public void start_stroke(Point p){
		stroke = new Vector();
		strokes.addElement(stroke);
		
		extend_stroke(p);
	}
	public void extend_stroke(Point p){
		stroke.addElement(p);
		repaint();
	}
	public void finish_stroke(Point p){
	}
	
	
	
	
	public void clear(){
		strokes = new Vector();
	}
	
	
	
	
   
   
	
	
	// central event dispatcher
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mouseDragged(MouseEvent e) {
			extend_stroke(e.getPoint());
   		}
  		public void mousePressed(MouseEvent e) {
			start_stroke(e.getPoint());
		}
		public void mouseReleased(MouseEvent e) {
			finish_stroke(e.getPoint());
		}
    }
}







